<!doctype html>
<html class="default no-js">
<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<title>RecoverAccountOperation | dblurt</title>
	<meta name="description" content="">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="../assets/css/main.css">
</head>
<body>
<header>
	<div class="tsd-page-toolbar">
		<div class="container">
			<div class="table-wrap">
				<div class="table-cell" id="tsd-search" data-index="../assets/js/search.js" data-base="..">
					<div class="field">
						<label for="tsd-search-field" class="tsd-widget search no-caption">Search</label>
						<input id="tsd-search-field" type="text" />
					</div>
					<ul class="results">
						<li class="state loading">Preparing search index...</li>
						<li class="state failure">The search index is not available</li>
					</ul>
					<a href="../index.html" class="title">dblurt</a>
				</div>
				<div class="table-cell" id="tsd-widgets">
					<div id="tsd-filter">
						<a href="#" class="tsd-widget options no-caption" data-toggle="options">Options</a>
						<div class="tsd-filter-group">
							<div class="tsd-select" id="tsd-filter-visibility">
								<span class="tsd-select-label">All</span>
								<ul class="tsd-select-list">
									<li data-value="public">Public</li>
									<li data-value="protected">Public/Protected</li>
									<li data-value="private" class="selected">All</li>
								</ul>
							</div>
							<input type="checkbox" id="tsd-filter-inherited" checked />
							<label class="tsd-widget" for="tsd-filter-inherited">Inherited</label>
							<input type="checkbox" id="tsd-filter-externals" checked />
							<label class="tsd-widget" for="tsd-filter-externals">Externals</label>
							<input type="checkbox" id="tsd-filter-only-exported" />
							<label class="tsd-widget" for="tsd-filter-only-exported">Only exported</label>
						</div>
					</div>
					<a href="#" class="tsd-widget menu no-caption" data-toggle="menu">Menu</a>
				</div>
			</div>
		</div>
	</div>
	<div class="tsd-page-title">
		<div class="container">
			<ul class="tsd-breadcrumb">
				<li>
					<a href="../globals.html">Globals</a>
				</li>
				<li>
					<a href="recoveraccountoperation.html">RecoverAccountOperation</a>
				</li>
			</ul>
			<h1>Interface RecoverAccountOperation</h1>
		</div>
	</div>
</header>
<div class="container container-main">
	<div class="row">
		<div class="col-8 col-content">
			<section class="tsd-panel tsd-comment">
				<div class="tsd-comment tsd-typography">
					<div class="lead">
						<p>Recover an account to a new authority using a previous authority and verification
							of the recovery account as proof of identity. This operation can only succeed
						if there was a recovery request sent by the account&#39;s recover account.</p>
					</div>
					<p>In order to recover the account, the account holder must provide proof
						of past ownership and proof of identity to the recovery account. Being able
						to satisfy an owner authority that was used in the past 30 days is sufficient
						to prove past ownership. The get_owner_history function in the database API
					returns past owner authorities that are valid for account recovery.</p>
					<p>Proving identity is an off chain contract between the account holder and
						the recovery account. The recovery request contains a new authority which
						must be satisfied by the account holder to regain control. The actual process
						of verifying authority may become complicated, but that is an application
					level concern, not a blockchain concern.</p>
					<p>This operation requires both the past and future owner authorities in the
						operation because neither of them can be derived from the current chain state.
						The operation must be signed by keys that satisfy both the new owner authority
					and the recent owner authority. Failing either fails the operation entirely.</p>
					<p>If a recovery request was made inadvertantly, the account holder should
					contact the recovery account to have the request deleted.</p>
					<p>The two setp combination of the account recovery request and recover is
						safe because the recovery account never has access to secrets of the account
						to recover. They simply act as an on chain endorsement of off chain identity.
						In other systems, a fork would be required to enforce such off chain state.
						Additionally, an account cannot be permanently recovered to the wrong account.
						While any owner authority from the past 30 days can be used, including a compromised
						authority, the account can be continually recovered until the recovery account
						is confident a combination of uncompromised authorities were used to
						recover the account. The actual process of verifying authority may become
						complicated, but that is an application level concern, not the blockchain&#39;s
					concern.</p>
				</div>
			</section>
			<section class="tsd-panel tsd-hierarchy">
				<h3>Hierarchy</h3>
				<ul class="tsd-hierarchy">
					<li>
						<a href="operation.html" class="tsd-signature-type">Operation</a>
						<ul class="tsd-hierarchy">
							<li>
								<span class="target">RecoverAccountOperation</span>
							</li>
						</ul>
					</li>
				</ul>
			</section>
			<section class="tsd-panel-group tsd-index-group">
				<h2>Index</h2>
				<section class="tsd-panel tsd-index-panel">
					<div class="tsd-index-content">
						<section class="tsd-index-section ">
							<h3>Properties</h3>
							<ul class="tsd-index-list">
								<li class="tsd-kind-property tsd-parent-kind-interface tsd-is-overwrite"><a href="recoveraccountoperation.html#0" class="tsd-kind-icon">0</a></li>
								<li class="tsd-kind-property tsd-parent-kind-interface tsd-is-overwrite"><a href="recoveraccountoperation.html#1" class="tsd-kind-icon">1</a></li>
							</ul>
						</section>
					</div>
				</section>
			</section>
			<section class="tsd-panel-group tsd-member-group ">
				<h2>Properties</h2>
				<section class="tsd-panel tsd-member tsd-kind-property tsd-parent-kind-interface tsd-is-overwrite">
					<a name="0" class="tsd-anchor"></a>
					<h3>0</h3>
					<div class="tsd-signature tsd-kind-icon">0<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-type">"recover_account"</span></div>
					<aside class="tsd-sources">
						<p>Overrides <a href="operation.html">Operation</a>.<a href="operation.html#0">0</a></p>
						<ul>
							<li>Defined in chain/operation.ts:613</li>
						</ul>
					</aside>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-property tsd-parent-kind-interface tsd-is-overwrite">
					<a name="1" class="tsd-anchor"></a>
					<h3>1</h3>
					<div class="tsd-signature tsd-kind-icon">1<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-symbol">{ </span>account_to_recover<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span><span class="tsd-signature-symbol">; </span>extensions<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">any</span><span class="tsd-signature-symbol">[]</span><span class="tsd-signature-symbol">; </span>new_owner_authority<span class="tsd-signature-symbol">: </span><a href="authoritytype.html" class="tsd-signature-type">AuthorityType</a><span class="tsd-signature-symbol">; </span>recent_owner_authority<span class="tsd-signature-symbol">: </span><a href="authoritytype.html" class="tsd-signature-type">AuthorityType</a><span class="tsd-signature-symbol"> }</span></div>
					<aside class="tsd-sources">
						<p>Overrides <a href="operation.html">Operation</a>.<a href="operation.html#1">1</a></p>
						<ul>
							<li>Defined in chain/operation.ts:614</li>
						</ul>
					</aside>
					<div class="tsd-type-declaration">
						<h4>Type declaration</h4>
						<ul class="tsd-parameters">
							<li class="tsd-parameter">
								<h5>account_<wbr>to_<wbr>recover<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span></h5>
								<div class="tsd-comment tsd-typography">
									<div class="lead">
										<p>The account to be recovered.</p>
									</div>
								</div>
							</li>
							<li class="tsd-parameter">
								<h5>extensions<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">any</span><span class="tsd-signature-symbol">[]</span></h5>
								<div class="tsd-comment tsd-typography">
									<div class="lead">
										<p>Extensions. Not currently used.</p>
									</div>
								</div>
							</li>
							<li class="tsd-parameter">
								<h5>new_<wbr>owner_<wbr>authority<span class="tsd-signature-symbol">: </span><a href="authoritytype.html" class="tsd-signature-type">AuthorityType</a></h5>
								<div class="tsd-comment tsd-typography">
									<div class="lead">
										<p>The new owner authority as specified in the request account recovery operation.</p>
									</div>
								</div>
							</li>
							<li class="tsd-parameter">
								<h5>recent_<wbr>owner_<wbr>authority<span class="tsd-signature-symbol">: </span><a href="authoritytype.html" class="tsd-signature-type">AuthorityType</a></h5>
								<div class="tsd-comment tsd-typography">
									<div class="lead">
										<p>A previous owner authority that the account holder will use to prove
										past ownership of the account to be recovered.</p>
									</div>
								</div>
							</li>
						</ul>
					</div>
				</section>
			</section>
		</div>
		<div class="col-4 col-menu menu-sticky-wrap menu-highlight">
			<nav class="tsd-navigation primary">
				<ul>
					<li class="globals  ">
						<a href="../globals.html"><em>Globals</em></a>
					</li>
				</ul>
			</nav>
			<nav class="tsd-navigation secondary menu-sticky">
				<ul class="before-current">
				</ul>
				<ul class="current">
					<li class="current tsd-kind-interface">
						<a href="recoveraccountoperation.html" class="tsd-kind-icon">Recover<wbr>Account<wbr>Operation</a>
						<ul>
							<li class=" tsd-kind-property tsd-parent-kind-interface tsd-is-overwrite">
								<a href="recoveraccountoperation.html#0" class="tsd-kind-icon">0</a>
							</li>
							<li class=" tsd-kind-property tsd-parent-kind-interface tsd-is-overwrite">
								<a href="recoveraccountoperation.html#1" class="tsd-kind-icon">1</a>
							</li>
						</ul>
					</li>
				</ul>
				<ul class="after-current">
				</ul>
			</nav>
		</div>
	</div>
</div>
<footer class="with-border-bottom">
	<div class="container">
		<h2>Legend</h2>
		<div class="tsd-legend-group">
			<ul class="tsd-legend">
				<li class="tsd-kind-constructor tsd-parent-kind-class"><span class="tsd-kind-icon">Constructor</span></li>
				<li class="tsd-kind-property tsd-parent-kind-class"><span class="tsd-kind-icon">Property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class"><span class="tsd-kind-icon">Method</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-private"><span class="tsd-kind-icon">Private property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class tsd-is-private"><span class="tsd-kind-icon">Private method</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-property tsd-parent-kind-interface"><span class="tsd-kind-icon">Property</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-method tsd-parent-kind-class tsd-is-static"><span class="tsd-kind-icon">Static method</span></li>
			</ul>
		</div>
	</div>
</footer>
<div class="container tsd-generator">
	<p>Generated using <a href="https://typedoc.org/" target="_blank">TypeDoc</a></p>
</div>
<div class="overlay"></div>
<script src="../assets/js/main.js"></script>
<script>if (location.protocol == 'file:') document.write('<script src="../assets/js/search.js"><' + '/script>');</script>
</body>
</html>